<div style="padding-bottom: 30px;">
    <table class="cr-table">
        <thead>
            <tr>
                <th *ngFor="let item of columns">
                    {{ item.label }}
                </th>
            </tr>
        </thead>
        <tbody>

            <tr *ngIf="dataValues.length == 0">
                <ng-container *ngIf="isLoading">
                    <td [colSpan]="columns ? columns.length : 0" class="no-data-row" style="padding: 5px;">
                        <mat-spinner diameter="20" color="primary" class="center-spinner" style="display: inline-block;margin-right: 10px;"></mat-spinner>
                        <div style="height:20px;margin-top: -5px;display: inline-block;vertical-align: text-bottom;">Loading..</div>
                    </td>
                </ng-container>
                <ng-container *ngIf="!isLoading">
                    <td [colSpan]="columns ? columns.length : 0" class="no-data-row">
                        No {{entity|titlecase}} Found
                    </td>
                </ng-container>
            </tr>
            <tr *ngFor="let row of dataValues">
                <td *ngFor="let column of columns">
                    <span *ngIf="
                            column.type != 'i18n' &&
                            column.type != 'status' &&
                            column.type != 'action' &&
                            !column.header
                        " (click)="getRecord(row._id)">
                        <ng-container *ngIf="column.htmlContent">
                            <span [innerHtml]="row[(column?.name)]"></span>
                        </ng-container>
                        <ng-container *ngIf="!column.htmlContent">
                            <span *ngIf="column.prefix">
                                {{ column.prefix }}
                            </span>
                            <span *ngIf="column.lov">
                                {{ getFiltered(row[(column?.name)], column) }}
                            </span>
                            <span *ngIf="!column.lov">
                                <ng-container *ngIf="column.booleanIcon">
                                    <ng-container *ngIf="row[(column?.name)]">
                                        <mat-icon color="primary">check_circle</mat-icon>
                                    </ng-container>
                                    <ng-container *ngIf="!row[(column?.name)]">
                                        <mat-icon color="warn">cancel</mat-icon>
                                    </ng-container>
                                </ng-container>
                                <ng-container *ngIf="!column.booleanIcon">
                                    {{ row[(column?.name)] }}
                                </ng-container>
                            </span>
                            <span *ngIf="column.postfix">
                                {{ column.postfix }}
                            </span>
                            <!-- {{ column | json }} -->
                        </ng-container>
                    </span>
                    <span *ngIf="
                            column.type != 'i18n' &&
                            column.type != 'status' &&
                            column.type != 'action' &&
                            column.header
                        " (click)="getRecord(row._id)">
                        <span *ngIf="column.prefix">
                            {{ column.prefix }}
                        </span>
                        <ng-container *ngIf="column.htmlContent">
                            <span
                                [innerHtml]="row[(column?.header)][(column?.name)] | slice:0:(column.truncateTo || defaultTruncate)"></span>
                        </ng-container>
                        <ng-container *ngIf="!column.htmlContent">
                            <ng-container *ngIf="column.booleanIcon">
                                <ng-container *ngIf="row[(column?.header)][(column?.name)]">
                                    <mat-icon color="primary">check_circle</mat-icon>
                                </ng-container>
                                <ng-container *ngIf="!row[(column?.header)][(column?.name)]">
                                    <mat-icon color="warn">cancel</mat-icon>
                                </ng-container>
                            </ng-container>
                            <ng-container *ngIf="column.date">
                                {{ row[(column?.header)][(column?.name)] | slice:0:(column.truncateTo ||
                                defaultTruncate) | date: column.dateFormat || 'medium' }}
                            </ng-container>
                            <ng-container *ngIf="!column.date && !column.booleanIcon">
                                {{ row[(column?.header)][(column?.name)] | slice:0:(column.truncateTo ||
                                defaultTruncate) }}
                            </ng-container>
                        </ng-container>
                        <span
                            *ngIf="row[(column?.header)][(column?.name)].length > (column.truncateTo || defaultTruncate)">...</span>
                        <span *ngIf="column.postfix">
                            {{ column.postfix }}
                        </span>
                    </span>
                    <span *ngIf="column.type == 'i18n' && !column.header" (click)="getRecord(row._id)">
                        <span *ngIf="column.prefix">
                            {{ column.prefix }}
                        </span>
                        <ng-container *ngIf="column.htmlContent">
                            <span
                                [innerHtml]="row[(column?.name)]?.en | slice:0:(column.truncateTo || defaultTruncate)"></span>
                        </ng-container>
                        <ng-container *ngIf="!column.htmlContent">
                            {{ row[(column?.name)]?.en | slice:0:(column.truncateTo || defaultTruncate) }}
                        </ng-container>
                        <span *ngIf="row[(column?.name)]?.en.length > (column.truncateTo || defaultTruncate)">...</span>
                        <br *ngIf="!column.singleLine">
                        <span *ngIf="row && row[column.name] && row[column.name].ar">
                            <ng-container *ngIf="column.htmlContent">
                                <span
                                    [innerHtml]="row[(column?.name)]?.ar | slice:0:((column.truncateTo || defaultTruncate)*5)">
                                </span>
                            </ng-container>
                            <ng-container *ngIf="!column.htmlContent">
                                {{ row[(column?.name)]?.ar | slice:0:((column.truncateTo || defaultTruncate)*5) }}
                            </ng-container>
                        </span>
                        <span
                            *ngIf="row[(column?.name)]?.ar.length > ((column.truncateTo || defaultTruncate)*5)">...</span>
                        <span *ngIf="column.postfix">
                            {{ column.postfix }}
                        </span>
                    </span>
                    <span class="" *ngIf="column.type == 'i18n' && column.header" (click)="getRecord(row._id)">
                        <span *ngIf="column.prefix">
                            {{ column.prefix }}
                        </span>
                        <span
                            *ngIf="row && row[column.header] && row[column.header][column.name] && row[column.header][column.name].en">
                            <ng-container *ngIf="column.htmlContent">
                                <span
                                    [innerHtml]="row[(column?.header)][(column?.name)]?.en | slice:0:(column.truncateTo || defaultTruncate)"></span>
                            </ng-container>
                            <ng-container *ngIf="!column.htmlContent">
                                {{ row[(column?.header)][(column?.name)]?.en | slice:0:(column.truncateTo ||
                                defaultTruncate) }}
                            </ng-container>
                        </span>
                        <span
                            *ngIf="row[(column?.header)][(column?.name)]?.en.length > (column.truncateTo || defaultTruncate)">...</span>
                        <br *ngIf="!column.singleLine">
                        <span
                            *ngIf="row && row[column.header] && row[column.header][column.name] && row[column.header][column.name].ar">
                            <ng-container *ngIf="column.htmlContent">
                                <span
                                    [innerHtml]="row[(column?.header)][(column?.name)]?.ar | slice:0:((column.truncateTo || defaultTruncate)*5)">
                                </span>
                            </ng-container>
                            <ng-container *ngIf="!column.htmlContent">
                                {{ row[(column?.header)][(column?.name)]?.ar | slice:0:((column.truncateTo ||
                                defaultTruncate)*5) }}
                            </ng-container>
                        </span>
                        <span
                            *ngIf="row[(column?.header)][(column?.name)]?.ar.length > ((column.truncateTo || defaultTruncate)*5)">...</span>
                        <span *ngIf="column.postfix">
                            {{ column.postfix }}
                        </span>
                    </span>
                    <span class="" *ngIf="column.type == 'status'" (click)="getRecord(row._id)">
                        <span *ngIf="row[column.name]"> Active</span>
                        <span *ngIf="!row[column.name]"> Inactive</span>
                    </span>
                    <span *ngIf="column.type == 'action'" style="width: 100px;">
                        <span style="width: 100px;">
                            <span class="" *ngIf="toggleStatus" (click)="toggleStatusTrigger(row._id)"
                                style="margin-right: 10px;">
                                <button mat-icon-button aria-label="" class="icon-button" matTooltip="Toggle Status"
                                    matTooltipPosition="below" matTooltipClass="action-tooltip">
                                    <mat-icon *ngIf="row.isActive" class="icon material-icons-outlined">visibility
                                    </mat-icon>
                                    <mat-icon *ngIf="!row.isActive" class="icon material-icons-outlined">visibility_off
                                    </mat-icon>
                                </button>
                            </span>
                            <span class="" *ngIf="hideView" (click)="getRecord(row._id)" style="margin-right: 10px;">
                                <button mat-icon-button aria-label="" class="icon-button" matTooltip="View"
                                    matTooltipPosition="below" matTooltipClass="action-tooltip">
                                    <mat-icon class="icon material-icons-outlined">visibility</mat-icon>
                                </button>
                            </span>
                            <span class="" *ngIf="!hideEdit" (click)="editRecord(row._id)" style="margin-right: 10px;">
                                <button mat-icon-button aria-label="" class="icon-button" matTooltip="Edit"
                                    matTooltipPosition="below" matTooltipClass="action-tooltip">
                                    <mat-icon class="icon material-icons-outlined">rate_review</mat-icon>
                                </button>
                            </span>
                            <span class="" *ngIf="!hideDelete" (click)="deleteRecord(row._id)"
                                style="margin-right: 10px;">
                                <button mat-icon-button aria-label="" class="icon-button" matTooltip="Delete"
                                    matTooltipPosition="below" matTooltipClass="action-tooltip">
                                    <mat-icon class="icon material-icons-outlined">delete_sweep_outline</mat-icon>
                                </button>
                            </span>
                        </span>
                    </span>
                </td>
            </tr>
        </tbody>
        <tfoot>
            <tr>
                <td [colSpan]="columns ? columns.length : 0">
                    <cr-pagination *ngIf="totalCount > 0" [totalItems]="totalCount" [currentPage]="params.page"
                        [perPage]="params.perPage" (changePage)=changePage($event)></cr-pagination>
                </td>
            </tr>
        </tfoot>
    </table>
</div>